unit TrackingRatesCol_Unit;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  ComObj, ActiveX, MCMT32_ASCOM_TLB, StdVcl;

type
  TTrackingRatesCol = class(TAutoObject, ITrackingRatesCol, IEnumVARIANT)
   private
      fIndex,fCount:integer;
  protected
    function Get__NewEnum: IUnknown; safecall;
    function Get_Count: Integer; safecall;
    { Protected declarations }
   { IEnumVARIANT }
      function Next(celt: LongWord; var rgvar : OleVariant;
         out pceltFetched: LongWord): HResult; stdcall;
      function Skip(celt: LongWord): HResult; stdcall;
      function Reset: HResult; stdcall;
      function Clone(out Enum: IEnumVariant): HResult; stdcall;
    function Get_Item(Index: Integer): DriveRates; safecall;
   public
      procedure Initialize; override;
      destructor Destroy; override;
  end;

implementation

uses ComServ,Data.Win.ADODB,Core,SysUtils;

procedure TTrackingRatesCol.Initialize;
begin
   inherited;
   fIndex:=0;
   fCount:=4;
end;

destructor TTrackingRatesCol.Destroy;
begin
   inherited;
end;

function TTrackingRatesCol.Get__NewEnum: IUnknown;
begin
//   result:=self as IEnumVARIANT;
  result:=self;
  findex:=0;
end;

function TTrackingRatesCol.Get_Count: Integer;
begin
   result:=fCount;
   WriteToTrace(Format('Get TrackingRates count=%d',[fCount]));
end;

function TTrackingRatesCol.Next(celt: LongWord; var rgvar : OleVariant; out pCeltFetched : LongWord) : HRESULT;
var i:integer;
begin
   i:=0;
   while (i<integer(celt)) and (fIndex<fCount) do
   begin
      TVariantList(rgvar)[i]:=Get_Item(i);
      inc(i);
      inc(fIndex);
   end;
   if (@pCeltFetched <> nil) then pCeltFetched:=i;
   if i=integer(celt) then result:=S_OK else result:=S_FALSE;
end;

function TTrackingRatesCol.Skip(celt: LongWord): HResult;
begin
   if (fIndex+integer(celt))<=fCount then
   begin
      inc(fIndex,celt);
      result:=S_OK;
   end
   else
   begin
      fIndex:=fCount-1;
      result:=S_FALSE;
   end;
end;

function TTrackingRatesCol.Reset: HResult;
begin
   fIndex:=0;
   result:=S_OK;
end;

function TTrackingRatesCol.Clone(out Enum: IEnumVariant): HResult;
begin
   result:=S_OK;
end;

function TTrackingRatesCol.Get_Item(Index: Integer): DriveRates;
var
   retour: DriveRates;
begin
   Case Index of
      1: Retour:=driveSidereal;
      2: Retour:=driveLunar;
      3: Retour:=driveSolar;
      4: Retour:=driveKing;
   end;
   WriteToTrace(Format('Get TrackingRates index %d=%d',[Index,ShortInt(Retour)]));
   result:=Retour;
end;

initialization
  TAutoObjectFactory.Create(ComServer, TTrackingRatesCol, Class_TrackingRatesCol,
    ciMultiInstance, tmApartment);
end.
